{% extends 'test_base_2.html' %}

{% block title %} Dashboard {% endblock %}

<!-- Specific Page CSS goes HERE  -->
{% block stylesheets %}
    <link href="/static/assets/css/app.css" rel="stylesheet">
    <link href="/static/assets/css/current_process.css" rel="stylesheet">
{% endblock %}

{% block content %}

<main class="content">

    <div class="container-fluid p-0">

        <div class="row mb-2 mb-xl-3">
            <div class="col-auto d-none d-sm-block">
                <h3><strong>Aktueller</strong> Prozess</h3>
            </div>

            <div class="col-auto ml-auto text-right mt-n1">
                <nav aria-label="breadcrumb">
                    <ol class="breadcrumb bg-transparent p-0 mt-1 mb-0">
                        <li class="breadcrumb-item"><a href="/">Saviour</a></li>
                        <li class="breadcrumb-item active" aria-current="page">Analyse</li>
                    </ol>
                </nav>
            </div>
        </div>

        <!-- Button and Modal to start a new process -->
        <form method="post">
            <!-- Modal to start a new process -->
            <div class="modal fade" id="newProcessModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="exampleModalLabel">Prozess beenden</h5>
                        </div>
                        <div class="modal-body">
                            <div class="form-group">
                                <p>Achtung! Wenn Sie den Prozess beenden, werden keine weiteren Daten für diesen Prozess mehr an die Datenbank übertragen.</p>
                            </div>
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-secondary" data-dismiss="modal">Abbrechen</button>
                            <button type="submit" class="btn btn-primary" name="new_process_button" value="stopp_process">Prozess beenden</button>
                        </div>
                    </div>
                </div>
            </div>

            <!-- Button, which leads to the new process modal -->
            <div class="new_process">
                {% if process_step_id == "not_yet_given" %}
                    <!-- <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#newProcessModal" name="new_process_button_two" value="on" id="new_process_button_id">Prozess starten</button> -->
                    <button type="submit" class="btn btn-primary" name="new_process_button_two" value="on">Prozess starten</button>
                {% else %}
                    <button type="button" class="btn btn-primary" name="new_process_button_two" value="off" data-toggle="modal" data-target="#newProcessModal">Prozess beenden</button>
                    <!-- <button type="submit" class="btn btn-primary" name="new_process_button_two" value="off">Prozess beenden</button> -->
                {% endif %}
            </div>
        </form>

        <!-- print the time of the current Process -->
        <p id="demo"></p>

        <!-- Graphs for live MQTT data -->
        <div class="row">
          {% for item in list_of_sensors %}
          <div class="col-xl-6 col-xxl-6">
            <div class="card flex-fill w-100">
              <div class="card-header">
                <h5 class="card-title mb-0">{{item[2]}}</h5>
              </div>
              <div class="card-body py-3">
                <div class="chart chart-sm">
                  <canvas id="Chart_{{item}}" height="100"></canvas>
                </div>
              </div>
            </div>
          </div>
          {% endfor %}
        </div>

    </div>
</main>

{% endblock content %}

<!-- Specific Page JS goes HERE  -->
{% block javascripts %}

<!--suppress JSUnresolvedLibraryURL -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.4.0/jquery.min.js"></script>
<!--suppress JSUnresolvedLibraryURL -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.3.1/js/bootstrap.min.js"></script>
<!--suppress JSUnresolvedLibraryURL -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.8.0/Chart.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/socket.io/4.0.1/socket.io.js"></script>
<script src="https://unpkg.com/mqtt/dist/mqtt.min.js"></script>


<script>
  /* script to create and update all charts of this document */

  // function creates charts with specific config
  function mySaviourChart(ctx, yLabelString) {
    let config = {
      type: 'line',
      data: {
        labels: [],
        datasets: [{
          label: "Random Dataset",
          backgroundColor: "rgba(215, 227, 244, 0)",
          borderColor: window.theme.primary,
          data: [],
          fill: true,
        }],
      },
      options: {
        elements: {
          point:{
            radius: 0
          }
        },
        spanGaps: true,
        responsive: true,
        legend: {
          display: false
        },
        tooltips: {
          mode: 'null',
        },
        hover: {
          mode: 'null',
        },
        scales: {
          xAxes: [{
            display: true,
            scaleLabel: {
                display: true,
                labelString: 'Zeit'
            },
            ticks: {
                maxTicksLimit: 6,
                maxRotation: 0,
            }
          }],
          yAxes: [{
            display: true,
            scaleLabel: {
              display: true,
              labelString: yLabelString
            }
          }]
        }
      }
    };
    let lineChart = new Chart(ctx, config);
    return lineChart;
  };

  // function to add data to chart
  function addData(chart, label, data) {
      chart.data.labels.push(label);
      chart.data.datasets.forEach((dataset) => {
          dataset.data.push(data);
      });
      chart.update();
  };

  // function to convert time
  function milliseconds_to_time(milliseconds) {
      // Time calculations for days, hours, minutes and seconds
      // These calculations are performed on the timestamp for the display of the data in the charts
      var days = Math.floor(milliseconds / (1000 * 60 * 60 * 24));
      var hours = Math.floor((milliseconds % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));
      var minutes = Math.floor((milliseconds % (1000 * 60 * 60)) / (1000 * 60));
      var seconds = Math.floor((milliseconds % (1000 * 60)) / 1000);
      if (minutes < 10){
          minutes = "0" + minutes
      }
      if (seconds < 10){
          seconds = "0" + seconds
      }
      return hours + ":" + minutes + ":" + seconds;
  };

  // create an array with all canvases in this document
  let canvases = Array.from(document.getElementsByTagName("canvas"));
  // create an empty array to collect all charts in there
  let lineCharts = [];
  // get list of sensor data to use as yLabelString
  let list_of_sensors_json = JSON.parse({{ list_of_sensors_json | tojson }});
  let listOfSensors = JSON.parse(list_of_sensors_json);
  // loop over all canvases to create them and put all charts in lineCharts
  // Charts are sorted according to their corresponding sensor id, thus index
  // of chart and sensor id is the same
  canvases.forEach((canvas, index) => {
    let ctx = canvas.getContext("2d");
    let yLabelString = listOfSensors.unit[index];
    let lineChart = mySaviourChart(ctx, yLabelString);
    lineCharts.push(lineChart);
  });

  var x2 = setInterval(function() {
    // when the process is running, the charts are beeing updated with the
    // last entry from the database every second
    if (process_step_id != "not_yet_given"){
      var xhttp = new XMLHttpRequest();
      xhttp.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200) {
          // for every sensor id in list of data (see app3 update_charts() )
          for (var sensor_id in JSON.parse(this.responseText)["sensor_id"]){
            // store sensor id of this data item in variable named sensorId
            let sensorId = JSON.parse(this.responseText)["sensor_id"][sensor_id];
            // charts are sorted according to their sensor id
            // but sensor ids start at 1, while lineChart index starts at 0
            let chartIndex = sensorId - 8;
            // add data to corresponding chart
            addData (lineCharts[chartIndex],
                      [milliseconds_to_time(JSON.parse(this.responseText)["timestamp"][sensor_id])],
                      [JSON.parse(this.responseText)["value"][sensor_id]]
                    );
          }
        }
      };
      xhttp.open("GET", "updatecharts", true);
      xhttp.send();
    }
  }, 1000);
</script>



<!-- ----------------------------------------------------------------------- -->


<script>
    // show the runtime of the current process
    var process_step_id = {{process_step_id| tojson}};
    var process_step_time = {{process_step_time| tojson}};
    var countDownDate = new Date(process_step_time).getTime();

    // Update the count down every 1 second
    var x = setInterval(function() {
        if (process_step_id != "not_yet_given") {
            // Get today's date and time
            var now = new Date().getTime();

            // Find the distance between now and the count down date
            var distance = now - countDownDate;

            // Time calculations for days, hours, minutes and seconds
            var days = Math.floor(distance / (1000 * 60 * 60 * 24));
            var hours = Math.floor((distance % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));
            var minutes = Math.floor((distance % (1000 * 60 * 60)) / (1000 * 60));
            var seconds = Math.floor((distance % (1000 * 60)) / 1000);

            // Output the result in an element with id="demo"
            document.getElementById("demo").innerHTML = "Laufzeit aktueller Prozess: " + days + "d " + hours + "h "
            + minutes + "m " + seconds + "s ";
        }
        else {
            document.getElementById("demo").innerHTML = "Der Prozess wurde noch nicht gestartet"
        }
    }, 1000);
</script>

{% endblock javascripts %}
